function Initialize()
{
	//SRR_ELLIOT_WAVE_OSCILLATOR_INDICATOR_V1.01
	//Coded for AD 4.0 by SRR (aka Indigo-On), 2017-2018
	//   -  34-  
	//,   5- SMA,    
	//    (   "5/34 oscillator).
	//       .   
	//      .  
	//       .  
	// ""     ,  
	//  .
	// : https://www.mql5.com/ru/code/17191
	//
	// 4  
	//
	//v1.01	-	   .
	//v1.00	-	  .

	//   #1
	// :
	IndicatorName = "SRR_ELLIOT_V1";		// 
	PriceStudy = false;						//   
	// :
 	AddParameter("FastPeriod", 5, 2);		//  SMA (   = 5)
 	AddParameter("SlowPeriod", 34, 2);		//  SMA (   = 34)
	AddGlobalVariable("dK_UP", Types.Double, 0.0);			//      EMA
	AddGlobalVariable("dK_DOWN", Types.Double, 0.0);		//      EMA
	//   Candle
	AddInput("Input1", Inputs.Candle);
 	//  #1  -    EWO
	AddSeries("EWO", DrawAs.Custom, Color.Silver, AxisType.ZeroBased, true);
 	//  #2  -    UP
 	AddSeries("UP", DrawAs.Custom, Color.LimeGreen, true);
	//  #3  -    DOWN
	AddSeries("DOWN", DrawAs.Custom, Color.Orange, true);
	//  #4  -    MIDDLE
	AddSeries("MIDDLE", DrawAs.Custom, Color.Silver, true);
	//   
	AddLevel(0.0, Color.Silver, LineStyles.Solid, 1, "EWO");
}

function Evaluate()
{
	///////////////////////////////////////////////////////////
	///   
	///////////////////////////////////////////////////////////

	///////////////////////////////////////////////////////////
	///  ELLIOT WAVE OSCILLATOR
	///     EWO
	///////////////////////////////////////////////////////////
	// 
	//     UP  DOWN
	int iLevelsPeriod = (int)(SlowPeriod + Math.Ceiling(FastPeriod / 2.0));
	//
	//   
	//    
	if (CurrentIndex > 0)
		EWO = SMA(LIB.MID(Input1), FastPeriod)[0] - SMA(LIB.MID(Input1), SlowPeriod)[0];
	else
		EWO = 0.0;
	//
	//    UP
	// EMA
	if (CurrentIndex > iLevelsPeriod * 2)
		UP = (1.0 - dK_UP) * UP[-1] + dK_UP * EWO[0];
	else
	{
		UP = EWO[0];
		dK_UP = 2.0 / (iLevelsPeriod + 1.0);
	}
	//   UP (UP    "0")
	if (EWO[0] <= 0)
		UP = UP[-1];
	//
	//    DOWN
	// EMA
	if (CurrentIndex > iLevelsPeriod * 2)
		DOWN = (1.0 - dK_DOWN) * DOWN[-1] + dK_DOWN * EWO[0];
	else
	{
		DOWN = EWO[0];
		dK_DOWN = 2.0 / (iLevelsPeriod + 1.0);
	}
	//   DOWN (DOWN    "0")
	if (EWO[0] >= 0)
		DOWN = DOWN[-1];
	//
	//    MIDDLE
	MIDDLE = (UP[0] + DOWN[0]) * 0.5;

	///////////////////////////////////////////////////////////
	///    UP  
	///////////////////////////////////////////////////////////
	UP.DrawLine(Color.LimeGreen, LineStyles.DashSmall, 1);

	///////////////////////////////////////////////////////////
	///    DOWN  
	///////////////////////////////////////////////////////////
	DOWN.DrawLine(Color.Orange, LineStyles.DashSmall, 1);

	///////////////////////////////////////////////////////////
	///    MIDDLE  
	///////////////////////////////////////////////////////////
	MIDDLE.DrawLine(Color.Silver, LineStyles.DashSmall, 1);

	///////////////////////////////////////////////////////////
	///    EWO  
	///////////////////////////////////////////////////////////
	if (EWO[0] >= UP[0])
	{
		EWO.DrawLine(Color.LimeGreen, LineStyles.Solid, 2);
		UP.DrawChannel(EWO, Color.LimeGreen, 50);
	}
	else
		if (EWO[0] < DOWN[0])
		{
			EWO.DrawLine(Color.Orange, LineStyles.Solid, 2);
			DOWN.DrawChannel(EWO, Color.Orange, 50);
		}
		else
			EWO.DrawLine(Color.Silver, LineStyles.Solid, 2);
}
